	SUBROUTINE SNDOPR(MSG,MSGLEN,MSGID,REP,REPLEN,REPID,REPFLG)
C
C	THIS ROUTINE IS USED TO SEND A MESSAGE TO THE OPERATOR AND
C	OPTIONALLY WAIT FOR A REPLY.
C
C	THE ARGUMENTS ARE DEFINED AS:
C
C		MSG	- 120 CHARACTER VARIABLE THAT CONTAINS THE TEXT TO SEND
C		MSGLEN	- THE LENGTH OF THE STRING TO SEND
C		MSGID	- MESSAGE ID (OPTIONAL)
C
C		REP	- 120 CHARACTER VARIABLE THAT WILL CONTAIN THE OPR'S REPLY
C		REPLEN	- LENGTH OF THE OPERATOR'S REPLY
C		REPID	- MESSAGE ID REPLIED TO
C
C		REPFLG	- 0 = NO REPLY EXPECTED
C			  1 = REPLY EXPECTED
C
	IMPLICIT INTEGER (A-Z)
	PARAMETER IO$_READVBLK='31'X	!READ REQUEST FOR MAILBOX
	PARAMETER OPC$_RQ_RQST='3'X	!SEND MSG TO OPR
	PARAMETER OPC$M_NM_CENTRL='1'X	!WHICH OPERATOR
	PARAMETER IUNIT=-3		!UNIT FOR ACCEPT
	PARAMETER OUNIT=-2		!UNIT FOR TYPE
C
C DEFINE A FEW THINGS
C
	CHARACTER MSGTXT*128,REPTXT*128,CHNULL*1,MSG*(*),REP*(*)
	DIMENSION OPRIDS(2)
	INTEGER*2 IOSB(4)
	BYTE OPC$B_MS_TYPE,OPC$B_MS_TARGET,NULL
	EQUIVALENCE (OPC$B_MS_TYPE,MSGTXT(1:1)),
     1		    (OPC$B_MS_TARGET,MSGTXT(2:2)),
     2		    (OPC$L_MS_RQSTID,MSGTXT(5:5)),
     3		    (NULL,CHNULL),(OPRIDS(1),REPTXT(1:1))
	DATA OPC$B_MS_TYPE/OPC$_RQ_RQST/
	DATA OPC$B_MS_TARGET/OPC$M_NM_CENTRL/
	OPC$L_MS_RQSTID=MSGID
	MBXCHN=0
	REP(1:)=' '
	REPLEN=0
	IF(REPFLG.EQ.0) GOTO 10
	STS=SYS$CREMBX(,MBXCHN,,,,,%DESCR('TMPMBX'))
	IF((STS.AND.1).NE.1) CALL EXIT(STS)
10	LEN=MSGLEN+9
	IF(LEN.GT.128) LEN=128
	MSGTXT(9:LEN)=MSG(1:MSGLEN)
	NULL=0
	MSGTXT(LEN:LEN)=CHNULL
	STS=SYS$SNDOPR(%DESCR(MSGTXT(1:LEN)),%VAL(MBXCHN))
	IF((STS.AND.1).NE.1) CALL EXIT(STS)
	IF(REPFLG.EQ.0) RETURN
	STS=SYS$QIOW(,%VAL(MBXCHN),%VAL(IO$_READVBLK),IOSB,,,
     1		      %REF(REPTXT),%VAL(128),,,,)
	IF((IOSB(1).AND.1).NE.1) CALL EXIT(IOSB(1))
	REPLEN=IOSB(2)-8
	RBEG=1
	IF(LIB$LOCC('"',REPTXT(9:REPLEN+8)).NE.0) RBEG=2
	REPLEN=REPLEN+RBEG-1
	REP(1:1)='"'
	REP(RBEG:REPLEN)=REPTXT(9:REPLEN+8)
	REPID=OPRIDS(2)
	RETURN
	END
